using UnityEngine;
using UnityEngine.UI;
using System.Collections.Generic;
using System;
using System.Linq;


//the script contains the functions:
//when a user presses "Space" button, timer goes on
//when a user presses "Space" button while timer is on,
//then it will be stopped, new scramble will be generated
//and time will be saved;
//it also calculates average of 5, 12, 100 sovles, best time, 
//worst time and session mean
//when a user wants to switch tab, all data is being saved
//and loaded on the next tab i.e. "Statistics" tab.

public class Timerscript : MonoBehaviour
{
    static public List<float> results = new List<float>();

    public Text display;
    public Text scrambletext;
    public Text averagetime;
    public Text besttime;
    public Text worsttime;
    public Text lastsolves;

    public float best;
    public float worst;

    static public int index = 0;
    static public float value;
    public float total;
    bool status;
    public int i;
    public int numberofSolves;

    public float average;
    public float averageof5value = 0;
    public float averageof12value = 0;
    public float averageof100value = 0;

    public float valueof5elements;
    public float valueof12elements;
    public float valueof100elements;


    void Start()
    {
        status = false;
        CreateScramble();
        average = PlayerPrefs.GetFloat("Average", 0);
        best = PlayerPrefs.GetFloat("Best", 0);
        worst = PlayerPrefs.GetFloat("Worst", 0);

        numberofSolves = index;
        averageof5value = PlayerPrefs.GetFloat("Averageof5", averageof5value);
        averageof12value = PlayerPrefs.GetFloat("Averageof12", averageof12value);
        averageof100value = PlayerPrefs.GetFloat("Averageof100", averageof100value);
        lastsolves.text = PlayerPrefs.GetString("Last solves", lastsolves.text);
    }

    void Update()
    {

        if (Input.GetKeyUp(KeyCode.Space))
        {
            status = !status;
        }
        if (status)
            value += Time.deltaTime;


        if (Input.GetKeyUp(KeyCode.Space) && status == false)
        {
            CreateScramble();
            avgsession();
            results.Insert(index, (float)Math.Round(value, 2));
            index++;
            lastsolves.text = string.Join("  ", results);
            best = results.Min();
            worst = results.Max();
            besttime.text = best.ToString("0.00");
            worsttime.text = worst.ToString("0.00");
            averageof5Function();
            averageof12Function();
            averageof100Function();
        }

        if (Input.GetKeyUp(KeyCode.Space) && status == true)
        {
            value = 0;
        }

        display.text = value.ToString("0.00");
    }

    void OnDestroy()
    {
        Debug.Log("Destroyed");
        PlayerPrefs.SetFloat("Average", average);
        PlayerPrefs.SetFloat("Best", best);
        PlayerPrefs.SetFloat("Worst", worst);
        PlayerPrefs.SetFloat("Averageof5", averageof5value);
        PlayerPrefs.SetFloat("Averageof12", averageof12value);
        PlayerPrefs.SetFloat("Averageof100", averageof100value);
        PlayerPrefs.SetInt("Number of Solves", index);
        PlayerPrefs.SetString("Last solves", lastsolves.text);
    }
    public void avgsession()
    {
        total += value;
        i++;
        average = total / i;
        averagetime.text = average.ToString("0.00");
    }
    public void averageof5Function()
    {
        if (i >= 5)
        {
            for (int a = 0; a < 5; a++)
            {
                valueof5elements += results[a];
            }
            averageof5value = valueof5elements / 5;
            valueof5elements = 0;
        }
    }

    public void averageof12Function()
    {
        if (i >= 12)
        {
            for (int a = 0; a < 12; a++)
            {
                valueof12elements += results[a];
            }
            averageof12value = valueof12elements / 12;
            valueof12elements = 0;
        }
    }

    public void averageof100Function()
    {
        if (i >= 100)
        {
            for (int a = 0; a < 100; a++)
            {
                valueof100elements += results[a];
            }
            averageof100value = valueof100elements / 100;
            valueof100elements = 0;
        }
    }

    public void CreateScramble(int scramblelength = 19)
    {
        int _scramblelength = scramblelength - 1;
        string randomscramble = "";
        string[] characters = new string[] { "R ", "R' ", "R2 ",
            "L ", "L' ", "L2 ", "F ", "F' ", "F2 ", "B ", "B' ",
            "B2 ", "U ", "U' ", "U2 ", "D ", "D' ", "D2 " };
        for (int a = 0; a <= scramblelength; a++)
        {
            randomscramble = randomscramble + characters[UnityEngine.Random.Range(0, characters.Length)];
        }
        scrambletext.text = randomscramble;
    }


}