﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using TMPro;

//script is used when the user wants to switch between
//windows on "Profile" tab

public class UIManager : MonoBehaviour
{
    public static UIManager window;

    //Screen object variables
    public GameObject RegisterWindow;
    public GameObject LoginWindow;    
    public GameObject UserDataWindow;
    public GameObject TableOfUsersWindow;

    private void Awake()
    {
        if (window == null)
        {
            window = this;
        }
        else if (window != null)
        {
            Destroy(this);
        }
    }

    //Functions below are used for switching between 4 windows:
    //"Login", "Register", "User Data Input" and "Table of users"
  
    public void RegisterWindowOnCLick()
    {
        ClearScreen();
        RegisterWindow.SetActive(true);
    }

    public void LoginWindowOnClick()
    {
        ClearScreen();
        LoginWindow.SetActive(true);
    }

    public void UserDataWindowOnClick()
    {
        ClearScreen();
        UserDataWindow.SetActive(true);
    }

    public void TableOfUsersWindowOnClick()
    {
        ClearScreen();
        TableOfUsersWindow.SetActive(true);
    }
    public void ClearScreen()
    {
        RegisterWindow.SetActive(false);
        LoginWindow.SetActive(false);
        UserDataWindow.SetActive(false);
        TableOfUsersWindow.SetActive(false);
    }
}
